//
// Model.cpp
//
#include "stdafx.h"

#include "Model.h"

#include "OpenGLExtFuncs.h"

//void CModel::MakeArray()
void CModel::MakeVBO()
{
	// VBO ID z̐
	if( 0 == m_auiVboID[0] )
	{
		glGenBuffers( 3, m_auiVboID );
	}

	if( 0 == m_vIndexedTriangle.size() )
	{
		return;
	}

	// Op`_z
	unsigned int uiCountData = m_vIndexedTriangle.size() * 3 * 3;	// P̎Op`́AR_BP_͂RWlB
	float* afTriangleVertex = new float[uiCountData];
	for( unsigned int uiIndexTriangle = 0; uiIndexTriangle < m_vIndexedTriangle.size(); uiIndexTriangle++ )
	{
		afTriangleVertex[uiIndexTriangle * 9 + 0] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[0]].x;
		afTriangleVertex[uiIndexTriangle * 9 + 1] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[0]].y;
		afTriangleVertex[uiIndexTriangle * 9 + 2] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[0]].z;
		afTriangleVertex[uiIndexTriangle * 9 + 3] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[1]].x;
		afTriangleVertex[uiIndexTriangle * 9 + 4] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[1]].y;
		afTriangleVertex[uiIndexTriangle * 9 + 5] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[1]].z;
		afTriangleVertex[uiIndexTriangle * 9 + 6] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[2]].x;
		afTriangleVertex[uiIndexTriangle * 9 + 7] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[2]].y;
		afTriangleVertex[uiIndexTriangle * 9 + 8] = m_vVertex[m_vIndexedTriangle[uiIndexTriangle].m_ui3IndexVertex[2]].z;
	}
	glBindBuffer( GL_ARRAY_BUFFER, GetTriangleVertexVboID() );
	glBufferData( GL_ARRAY_BUFFER, uiCountData * sizeof( float ), afTriangleVertex, GL_STATIC_DRAW );
	glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉
	delete afTriangleVertex;	// VRAMɓ]f[^glBufferDataɂāAVRAMɃf[^uBRAMɃf[^͕svB

	// Ő_ԍz
	uiCountData = m_vIndexedTriangle.size() * 3 * 2;	// ̎Op`́AR̗ŐBP̗Ő́AQ̒_B
	unsigned int* auiEdgeVertexIndex = new unsigned int[uiCountData];
	for( unsigned int uiIndexTriangle = 0; uiIndexTriangle < m_vIndexedTriangle.size(); uiIndexTriangle++ )
	{
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 0] = uiIndexTriangle * 3 + 0;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 1] = uiIndexTriangle * 3 + 1;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 2] = uiIndexTriangle * 3 + 1;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 3] = uiIndexTriangle * 3 + 2;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 4] = uiIndexTriangle * 3 + 2;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 5] = uiIndexTriangle * 3 + 0;
	}
	glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, GetEdgeVertexIndexVboID() );
	glBufferData( GL_ELEMENT_ARRAY_BUFFER, uiCountData * sizeof( unsigned int ), auiEdgeVertexIndex, GL_STATIC_DRAW );
	glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, 0 );	// oCh̉
	delete auiEdgeVertexIndex;	// VRAMɓ]f[^glBufferDataɂāAVRAMɃf[^uBRAMɃf[^͕svB

	// Op`_@z
	uiCountData = m_vIndexedTriangle.size() * 3 * 3;	// 	// P̎Op`́AR_BP_͂RxNglB
	float* afTriangleVertexNormal = new float[uiCountData];
	for( unsigned int uiIndexTriangle = 0; uiIndexTriangle < m_vIndexedTriangle.size(); uiIndexTriangle++ )
	{
		// _ԍێOp`̎擾
		CIndexedTriangle& rIndexedTriangle = m_vIndexedTriangle[uiIndexTriangle];
		// Op`̂R_W̎擾
		CVector& rVertex0 = m_vVertex[rIndexedTriangle.m_ui3IndexVertex[0]];
		CVector& rVertex1 = m_vVertex[rIndexedTriangle.m_ui3IndexVertex[1]];
		CVector& rVertex2 = m_vVertex[rIndexedTriangle.m_ui3IndexVertex[2]];
		// P_ڂQ_ڂւ̃xNgAQ_ڂR_ڂւ̃xNg߂
		CVector vector01( rVertex1.x - rVertex0.x,
			rVertex1.y - rVertex0.y,
			rVertex1.z - rVertex0.z );
		CVector vector12( rVertex2.x - rVertex1.x,
			rVertex2.y - rVertex1.y,
			rVertex2.z - rVertex1.z );
		// Q̃xNg̖@xNg߂
		CVector vectorNormal = { vector01.y * vector12.z - vector01.z * vector12.y,
							vector01.z * vector12.x - vector01.x * vector12.z,
							vector01.x * vector12.y - vector01.y * vector12.x };
		float fLength = (float)sqrt( vectorNormal.x * vectorNormal.x + vectorNormal.y * vectorNormal.y + vectorNormal.z * vectorNormal.z );
		vectorNormal.x /= fLength;
		vectorNormal.y /= fLength;
		vectorNormal.z /= fLength;
		// @xNglzɃZbg
		afTriangleVertexNormal[uiIndexTriangle * 9 + 0] = vectorNormal.x;
		afTriangleVertexNormal[uiIndexTriangle * 9 + 1] = vectorNormal.y;
		afTriangleVertexNormal[uiIndexTriangle * 9 + 2] = vectorNormal.z;
		afTriangleVertexNormal[uiIndexTriangle * 9 + 3] = vectorNormal.x;
		afTriangleVertexNormal[uiIndexTriangle * 9 + 4] = vectorNormal.y;
		afTriangleVertexNormal[uiIndexTriangle * 9 + 5] = vectorNormal.z;
		afTriangleVertexNormal[uiIndexTriangle * 9 + 6] = vectorNormal.x;
		afTriangleVertexNormal[uiIndexTriangle * 9 + 7] = vectorNormal.y;
		afTriangleVertexNormal[uiIndexTriangle * 9 + 8] = vectorNormal.z;
	}
	glBindBuffer( GL_ARRAY_BUFFER, GetTriangleVertexNormalVboID() );
	glBufferData( GL_ARRAY_BUFFER, uiCountData * sizeof( float ), afTriangleVertexNormal, GL_STATIC_DRAW );
	glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉
	delete afTriangleVertexNormal;	// VRAMɓ]f[^glBufferDataɂāAVRAMɃf[^uBRAMɃf[^͕svB
}

//void CModel::DestroyArray()
void CModel::DestroyVBO()
{
	if( 0 == m_auiVboID[0] )
	{
		return;
	}

	glDeleteBuffers( 3, m_auiVboID );
	memset( m_auiVboID, 0x00, 3 * sizeof( unsigned int ) );
}
